config/routes.rb
Rails.application.routes.draw do
  resources :videos
  root to: "pages#home"
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  # root "articles#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/video.rb
class Video < ApplicationRecord
    has_one_attached :file
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/pages_controller.rb
class PagesController < ApplicationController
  def home
  end
end

app/controllers/videos_controller.rb
class VideosController < ApplicationController
  before_action :set_video, only: %i[ show edit update destroy ]

  # GET /videos or /videos.json
  def index
    @videos = Video.all

  end

  # GET /videos/1 or /videos/1.json
  def show
  end

  # GET /videos/new
  def new
    @video = Video.new
  end

  # GET /videos/1/edit
  def edit
  end

  # POST /videos or /videos.json
  def create

    @video = Video.new(video_params)
    respond_to do |format|
      if @video.save
        
        format.html { redirect_to videos_url, notice: "Video was successfully created." }
        format.json { render :show, status: :created, location: @video }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @video.errors, status: :unprocessable_entity }
      end
    end
  end


  # PATCH/PUT /videos/1 or /videos/1.json
  def update
    respond_to do |format|
      if @video.update(video_params)
        format.html { redirect_to video_url(@video), notice: "Video was successfully updated." }
        format.json { render :show, status: :ok, location: @video }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @video.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /videos/1 or /videos/1.json
  def destroy
    @video.destroy

    respond_to do |format|
      format.html { redirect_to videos_url, notice: "Video was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_video
      @video = Video.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def video_params
      params.require(:video).permit(:title, :description, :file)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>MyVideoRecordingApp</title>
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <%= javascript_importmap_tags %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/pages/home.html.erb
<h1>Pages#home</h1>
<p>Find me in app/views/pages/home.html.erb</p>

app/views/videos/_form.html.erb
<%= simple_form_for(@video) do |f| %>
  <%= f.error_notification %>
  <%= f.error_notification message: f.object.errors[:base].to_sentence if f.object.errors[:base].present? %>

  <div class="form-inputs">
    <%= f.input :title %>
    <%= f.input :description %>
    <%= f.input :file, as: :file %>
  </div>

  <div class="form-actions">
    <%= f.button :submit %>
  </div>
<% end %>

<br>
<br>


<video id="video" autoplay></video>
<button id="start">Start Recording</button>
<button id="stop">Stop Recording</button>

<script src="https://cdn.jsdelivr.net/npm/recordrtc"></script>


<script>
  var recorder;
  var video = document.getElementById("video");
  var start = document.getElementById("start");
  var stop = document.getElementById("stop");

  start.addEventListener("click", function() {
    navigator.mediaDevices.getUserMedia({audio: true, video: true}).then(function(stream) {
      video.srcObject = stream;
      recorder = RecordRTC(stream, {type: "video"});
      recorder.startRecording();
    });
  });

  stop.addEventListener("click", function() {
    recorder.stopRecording(function() {
      var blob = recorder.getBlob();
      var formData = new FormData();
      formData.append('video[file]', blob, "video.webm");
      formData.append('authenticity_token', '<%= form_authenticity_token %>');

        fetch('/videos', {
          method: 'POST',
          body: formData,
          headers: {
            'X-CSRF-Token': '<%= form_authenticity_token %>'
          }
        }).then(response => {
          // handle the response
        });
        
      var xhr = new XMLHttpRequest();
      xhr.open("POST", "/videos", true);
      xhr.send(formData);
    });
  });
</script>

app/views/videos/_video.html.erb
<div id="<%= dom_id video %>">
  <p>
    <strong>Title:</strong>
    <%= video.title %>
  </p>

  <p>
    <strong>Description:</strong>
    <%= video.description %>
    <video src="<%= url_for(video.file) %>" height="100" width="200" loop muted="muted" autoplay></video></td>
  </p>

</div>

app/views/videos/edit.html.erb
<h1>Editing video</h1>

<%= render "form", video: @video %>

<br>

<div>
  <%= link_to "Show this video", @video %> |
  <%= link_to "Back to videos", videos_path %>
</div>

app/views/videos/index.html.erb
<p style="color: green"><%= notice %></p>

<h1>Videos</h1>

<div id="videos">
  <% @videos.each do |video| %>
    <tr>
        <td><%= video.title %></td>
        <td><%= video.description %></td>
        <td><video src="<%= url_for(video.file) %>" height="400" width="400"  controls></video></td>
        <td><%= link_to 'Edit', edit_video_path(video) %></td>
        <td><%= link_to 'Destroy', video, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <p>
      <%= link_to "Show this video", video %>
    </p>
  <% end %>
</div>

<%= link_to "New video", new_video_path %>





<input type="file" accept="video/*;capture=camcorder">
<input type="file" accept="audio/*;capture=microphone">

<device type="media" onchange="update(this.data)"></device>
<video autoplay></video>
<script>
    function update(stream) {
    document.querySelector('video').src = stream.url;
    }
</script>

app/views/videos/new.html.erb
<h1>New video</h1>

<%= render "form", video: @video %>

<br>

<div>
  <%= link_to "Back to videos", videos_path %>
</div>

app/views/videos/show.html.erb
<p style="color: green"><%= notice %></p>

<%= @video.description %>
<td><video src="<%= url_for(@video.file) %>" height="400" width="800">

<div>
  <%= link_to "Edit this video", edit_video_path(@video) %> |
  <%= link_to "Back to videos", videos_path %>

  <%= button_to "Destroy this video", @video, method: :delete %>
</div>